---
layout: default
title: "Rust 2020: Write Once, Run Anywhere"
---
thing that is cool: writing the same codebase and having it run on desktop, mobile, and web

thing that is lame: JavaScript is the only language where people really do that right now, outside of big commercial game engines

things that need to happen for Rust to get there:
1. promote more platforms to tier 1, or maybe introduce a "tier 1.5" where std is guaranteed to work but rustc and cargo are not (although it'd be cool for rustc to work on WebAssembly)
   - iOS: `aarch64-apple-ios`, `armv7-apple-ios`, `i386-apple-ios`, `x86_64-apple-ios`
   - Android: `aarch64-linux-android`, `arm-linux-androideabi`, `i686-linux-android`, `thumbv7neon-linux-androideabi`, `x86_64-linux-android`
   - WebAssembly: `wasm32-unknown-unknown` (or one of the other `wasm32` targets)
2. test platform abstractions (graphics libraries, game engines, UI frameworks) on all of those
3. get some high-level examples together of how to use Rust to write performant cross-platform code
